bug-tar
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[Bug-tar] port of tar to latest Autoconf, Gnulib, Translation Project


From: Paul Eggert
Subject: [Bug-tar] port of tar to latest Autoconf, Gnulib, Translation Project
Date: Mon, 07 Aug 2006 16:01:59 -0700
User-agent: Gnus/5.1008 (Gnus v5.10.8) Emacs/21.4 (gnu/linux)

I installed the following to get tar bootstrapping working again.

In particular, this causes tar bootstrapping to sync to the latest
translations; the old method stopped working several months ago and
the translations were getting stale.

2006-08-07  Paul Eggert  <address@hidden>

        * bootstrap: Don't use --assume-autoconf; it's now replaced
        by looking in configure.ac.
        (m4/codeset.m4, m4/intdiv.m4, m4/inttypes-pri.m4, m4/isc-posix.m4):
        (m4/lcmessage.m4, m4/onceonly_2_57.m4, m4/gettext.m4, m4/glibc21.m4):
        (m4/inttypes_h.m4, m4/lib-ld.m4, m4/lib-prefix.m4, m4/po.m4):
        (m4/stdint_h.m4, m4/uintmax_t.m4, m4/ulonglong.m4):
        Don't rename to ..._gl.m4, as this is no longer needed.
        (m4/geteext.m4): Patch to remove the need for intl/*.
        Use autopoint manually, then remove the intl files,
        then undo changes to gnulib files that autoreconf made,
        and then run aclocal/autoconf/autoheader/automake.
        This makes our bootstrap procedure closer to Bison's.
        (po/Makevars): Generate automatically.
        * configure.ac (AC_PREREQ): Update from 2.59 to 2.60.
        (gl_AC_TYPE_INTMAX_T, jm_AC_TYPE_UINTMAX_T): Remove.
        * gnulib.modules: Add inttypes, stdint.
        * lib/.cvsignore: Add close-stream.c, close-stream.h,
        stdint.h, stdint_.h.
        * po/Makefile: Remove; now automatically generated.

        * src/incremen.c (read_incr_db_01): Check input strings more
        carefully.  Do not pass arbitrary char values to isspace, as
        this has undefined behavior.  Likewise for assigning arbitrary
        uintmax_t values to other types.
        (read_negative_num, read_unsigned_num, read_timespec):
        New functions, to check input values a bit more carefuly.
        (read_num): Use read_unsigned_num.  New arg MAX_VAL;
        all callers changed.
        (read_incr_db_2): Use these new functions.
        Use a consistent diagnostic for unexpected EOF.
        (read_directory_file): Do not assign arbitrary uintmax_t value
        to int.
        (read_timespec, write_directory_file_entry, write_directory_file):
        Handle negative time_t values correctly.  We don't bother to do
        this with pre-2 formats, since presumably the time stamps were
        output incorrectly.

        * src/tar.c (doc): Don't use \v in an argument to gettext;
        gettext 0.15 rejects this.
 
        * paxutils/lib/system.h: Include <inttypes.h> unconditionally.
        The latest gnulib lets us do this.
        * paxutils/m4/system.m4 (PU_SYSTEM): Don't check for inttypes.h
        Don't require gl_AC_TYPE_UINTMAX_T.
        Require gl_INTTYPES_H, gl_STDINT_H.

Index: bootstrap
===================================================================
RCS file: /cvsroot/tar/tar/bootstrap,v
retrieving revision 1.41
diff -p -u -r1.41 bootstrap
--- bootstrap   20 Jul 2006 16:57:31 -0000      1.41
+++ bootstrap   7 Aug 2006 22:55:47 -0000
@@ -1,6 +1,6 @@
 #! /bin/sh
 
-# Bootstrap 'tar' from CVS.
+# Bootstrap this package from CVS.
 
 # Copyright (C) 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
 
@@ -21,11 +21,13 @@
 
 # Written by Paul Eggert and Sergey Poznyakoff.
 
-# URL of our text domain page in Translation Project
-TP_URL="http://www.iro.umontreal.ca/translation/maint/tar/";
+package=tar
 
-# Ensure file names are sorted consistently across platforms;
-# e.g., m4/ulonglong_gl.m4 should follow m4/ulonglong.m4.
+# Translation Project URL, for the registry of all projects.
+TP_URL='http://www.iro.umontreal.ca/translation/registry.cgi?domain='
+
+# Ensure file names are sorted consistently across platforms.
+# Also, ensure diagnostics are in English, e.g., "wget --help" below.
 LC_ALL=C
 export LC_ALL
 
@@ -64,31 +66,6 @@ to
 EOF
 }
 
-update_po() {
-  if [ $# = 1 ]; then
-    case $1 in
-    *.po)  POFILE=$1;;
-    *)     POFILE=${1}.po;;
-    esac
-    echo "$0: getting translation for $1..."
-    (cd po;
-     wget -r --cache=off -O $POFILE $TP_URL/$POFILE || exit
-     LANG=`expr $POFILE : '\(.*\)\.po'`
-     if ! grep -q $LANG LINGUAS; then
-       mv LINGUAS LINGUAS.$$
-       (echo $LANG; cat LINGUAS.$$) | sort > LINGUAS
-     fi)
-  else
-    echo "$0: getting translations into po..."
-    (cd po &&
-     rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'` &&
-      wget -nv -nd -r -l 1 -A .po --cache off $TP_URL &&
-      rm -f index.html index.html.[0-9]*
-      ls *.po | sed 's/\.po$//' >LINGUAS
-    ) || exit
-  fi
-}
-
 # Read configuration file
 if [ -r .bootstrap ]; then
   echo "$0: Reading configuration file .bootstrap"
@@ -124,16 +101,87 @@ do
   esac
 done
 
+# Get translations.
+
+get_translations() {
+  subdir=$1
+  domain=$2
+  po_file=$3
+
+  echo "$0: getting translations into $subdir for $domain..."
+  (cd $subdir && rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'`) &&
+
+  $WGET_COMMAND -O "$subdir/$domain.html" "$TP_URL$domain" &&
+
+  sed -n 
's|.*"http://[^"]*/translation/teams/PO/\([^/"]*\)/'"$domain"'-\([^/"]*\)\.[^."]*\.po".*|\1.\2|p'
 <"$subdir/$domain.html" |
+  sort -k 1,1 -k 2,2n -k2,2 -k3,3n -k3,3 -k4,4n -k4,4 -k5,5n -k5.5 |
+  awk -F. '
+    { if (lang && $1 != lang) print lang, ver }
+    { lang = $1; ver = substr($0, index($0, ".") + 1) }
+    END { if (lang) print lang, ver }
+  ' |
+  awk -v domain="$domain" -v po_file="$po_file" -v subdir="$subdir" '
+    {
+      lang = $1
+      if (po_file == (lang ".po")) next
+
+      # Work around bugs in translations uncovered by gettext 0.15.
+      # This workaround can be removed once the translations are fixed.
+      if (lang == "hu" || lang == "ja" || lang == "ky" || lang == "zh_TW") next
+
+      ver = $2
+      urlfmt = ""
+      printf "$WGET_COMMAND -O %s/%s.po 
'http://www.iro.umontreal.ca/translation/teams/PO/%s/%s-%s.%s.po' &&\n", 
subdir, lang, lang, domain, ver, lang
+    }
+    END { print ":" }
+  ' |
+  sh &&
+  ls "$subdir"/*.po | sed 's|.*/||; s|\.po$||' >"$subdir/LINGUAS" &&
+  rm "$subdir/$domain.html"
+}
+
+update_po() {
+  if [ $# = 1 ]; then
+    case $1 in
+    *.po)  POFILE=$1;;
+    *)     POFILE=${1}.po;;
+    esac
+    get_translations po $package "$POFILE" &&
+    LANG=`expr $POFILE : '\(.*\)\.po'` &&
+    { grep -q $LANG po/LINGUAS ||
+        (echo $LANG; cat po/LINGUAS) | sort -o po/LINGUAS; }
+  else
+    get_translations po $package
+  fi
+}
+
+case $DOWNLOAD_PO in
+no) ;;
+*)
+  case `wget --help` in
+  *'--no-cache'*)
+    no_cache='--no-cache';;
+  *'--cache=on/off'*)
+    no_cache='--cache=off';;
+  *)
+    no_cache='';;
+  esac
+
+  WGET_COMMAND="wget -nv $no_cache"
+  export WGET_COMMAND
+esac
+
 case $DOWNLOAD_PO in
 only)  update_po
-       exit 0
+       exit
        ;;
 no|yes) ;;
 *)     update_po $DOWNLOAD_PO
-       exit 0
+       exit
 esac
 
-echo "$0: Bootstrapping CVS tar..."
+
+echo "$0: Bootstrapping CVS $package..."
 
 build_cvs_prefix() {
   CVS_PREFIX=:${1}:
@@ -242,8 +290,8 @@ case ${GNULIB_SRCDIR--} in
    GNULIB_SRCDIR=gnulib
 esac
 
-<$GNULIB_SRCDIR/gnulib-tool || exit
-gnulib_tool="$GNULIB_SRCDIR/gnulib-tool --assume-autoconf=latest-stable"
+gnulib_tool=$GNULIB_SRCDIR/gnulib-tool
+<$gnulib_tool || exit
 
 get_modules gnulib.modules
 
@@ -270,27 +318,21 @@ mkdir -p $gnulib_dirs || exit
 
 for gnulib_file in $gnulib_files; do
   dest=$gnulib_file
-
-  case $gnulib_file in
-  m4/codeset.m4) continue;;
-  m4/intdiv0.m4) continue;;
-  m4/inttypes-pri.m4) continue;;
-  m4/isc-posix.m4) continue;;
-  m4/lcmessage.m4) continue;;
-  m4/onceonly_2_57.m4) dest=m4/onceonly.m4;;
-  # These will be overwritten by autopoint, which still uses
-  # old jm_.* macro names, so we have to keep both copies.
-  m4/gettext.m4 | m4/glibc21.m4 | m4/inttypes_h.m4 | m4/lib-ld.m4 | \
-  m4/lib-prefix.m4 | m4/po.m4 | m4/stdint_h.m4 | m4/uintmax_t.m4 | \
-  m4/ulonglong.m4)
-    dest=`expr $gnulib_file : '\(.*\).m4'`_gl.m4;;
-  esac
-
   rm -f $dest &&
   echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file" &&
   cp -p $GNULIB_SRCDIR/$gnulib_file $dest || exit
 done
 
+# This suppresses a bogus diagnostic
+# "warning: macro `AM_LANGINFO_CODESET' not found in library".
+echo "$0: patching m4/gettext.m4 to remove need for intl/* ..."
+sed '
+  /^AC_DEFUN(\[AM_INTL_SUBDIR],/,/^]/c\
+    AC_DEFUN([AM_INTL_SUBDIR], [])
+  /^AC_DEFUN(\[gt_INTL_SUBDIR_CORE],/,/^]/c\
+    AC_DEFUN([gt_INTL_SUBDIR_CORE], [])
+' m4/gettext.m4 >m4/gettext_gl.m4 || exit
+
 echo "$0: Creating m4/gnulib.m4"
 (echo "# This file is generated automatically. Please, do not edit."
  echo "#"
@@ -317,8 +359,54 @@ fi
 
 # Reconfigure, getting other files.
 
-echo "$0: autoreconf --verbose --install --force ..."
-autoreconf --verbose --install --force || exit 1
+echo "$0: autopoint --force ..."
+autopoint --force || exit
+
+# We don't need intl, so remove it.
+intl_files_to_remove='
+  intl
+  m4/gettext.m4
+  m4/glibc2.m4
+  m4/intdiv0.m4
+  m4/intmax.m4
+  m4/inttypes-h.m4
+  m4/inttypes-pri.m4
+  m4/lcmessage.m4
+  m4/lock.m4
+  m4/printf-posix.m4
+  m4/visibility.m4
+'
+echo $0: rm -fr $intl_files_to_remove ...
+rm -fr $intl_files_to_remove || exit
+
+
+# Undo changes to gnulib files that autoreconf made.
+for gnulib_file in $gnulib_files; do
+  test ! -f $gnulib_file || cmp -s $gnulib_file $GNULIB_SRCDIR/$gnulib_file || 
{
+    rm -f $gnulib_file &&
+    echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file again" &&
+    cp -p $GNULIB_SRCDIR/$gnulib_file $gnulib_file || exit
+  }
+done
+
+# Make sure aclocal.m4 is not older than input files.
+sleep 1
+
+for command in \
+  'aclocal --force -I m4' \
+  'autoconf --force' \
+  'autoheader --force' \
+  'automake --add-missing --copy --force-missing';
+do
+  echo "$0: $command ..."
+  $command || exit
+done
+
+
+# Put bug-reporting address into po/Makevars.
+echo "$0: sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= address@hidden/' 
po/Makevars.template >po/Makevars ..."
+sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-'"$package"'@gnu.org/' 
po/Makevars.template >po/Makevars
+
 
 
 echo "$0: done.  Now you can run './configure'."
Index: configure.ac
===================================================================
RCS file: /cvsroot/tar/tar/configure.ac,v
retrieving revision 1.68
diff -p -u -r1.68 configure.ac
--- configure.ac        4 Jul 2006 21:51:33 -0000       1.68
+++ configure.ac        7 Aug 2006 22:55:47 -0000
@@ -22,7 +22,7 @@ AC_INIT([GNU tar], [1.15.92], address@hidden
 AC_CONFIG_SRCDIR([src/tar.c])
 AC_CONFIG_AUX_DIR([build-aux])
 AC_CONFIG_HEADERS([config.h:config.hin])
-AC_PREREQ([2.59])
+AC_PREREQ([2.60])
 AM_INIT_AUTOMAKE([1.9 gnits tar-ustar dist-bzip2 dist-shar std-options])
 
 gl_USE_SYSTEM_EXTENSIONS
@@ -80,8 +80,6 @@ AC_CHECK_TYPE(dev_t, unsigned)
 AC_CHECK_TYPE(ino_t, unsigned)
 
 gt_TYPE_SSIZE_T
-gl_AC_TYPE_INTMAX_T
-jm_AC_TYPE_UINTMAX_T
 
 # gnulib modules
 tar_GNULIB
Index: gnulib.modules
===================================================================
RCS file: /cvsroot/tar/tar/gnulib.modules,v
retrieving revision 1.9
diff -p -u -r1.9 gnulib.modules
--- gnulib.modules      8 Jun 2006 14:41:15 -0000       1.9
+++ gnulib.modules      7 Aug 2006 22:55:47 -0000
@@ -22,6 +22,7 @@ gettext
 gettime
 hash
 human
+inttypes
 lchown
 localcharset
 memset
@@ -38,6 +39,7 @@ savedir
 setenv
 stat-time
 stdbool
+stdint
 stpcpy
 strdup
 strtol
Index: lib/.cvsignore
===================================================================
RCS file: /cvsroot/tar/tar/lib/.cvsignore,v
retrieving revision 1.37
diff -p -u -r1.37 .cvsignore
--- lib/.cvsignore      17 Jul 2006 05:47:26 -0000      1.37
+++ lib/.cvsignore      7 Aug 2006 22:55:47 -0000
@@ -33,6 +33,8 @@ charset.alias
 chdir-long.c
 chdir-long.h
 chown.c
+close-stream.c
+close-stream.h
 closeout.c
 closeout.h
 config.charset
@@ -158,6 +160,8 @@ stat-macros.h
 stat-time.h
 stdbool.h
 stdbool_.h
+stdint.h
+stdint_.h
 stpcpy.c
 stpcpy.h
 strcase.h
--- paxutils/lib/system.h       25 Jun 2006 12:35:45 -0000      1.10
+++ paxutils/lib/system.h       7 Aug 2006 22:54:47 -0000
@@ -421,16 +421,7 @@ char *getenv ();
 # define MB_LEN_MAX 1
 #endif
 
-#if HAVE_INTTYPES_H
-# include <inttypes.h>
-#endif
-
-#if !HAVE_DECL_STRTOIMAX && !defined strtoimax
-intmax_t strtoimax ();
-#endif
-#if !HAVE_DECL_STRTOUMAX && !defined strtoumax
-uintmax_t strtoumax ();
-#endif
+#include <inttypes.h>
 
 #include <intprops.h>
 
--- paxutils/m4/system.m4       8 Mar 2006 00:28:51 -0000       1.5
+++ paxutils/m4/system.m4       7 Aug 2006 22:54:47 -0000
@@ -10,7 +10,7 @@ AC_DEFUN([PU_SYSTEM],[
 
   AC_CHECK_HEADERS_ONCE([string.h memory.h fcntl.h sys/wait.h \
  sys/gentape.h sys/tape.h sys/device.h sys/param.h sys/tprintf.h sys/mtio.h \
- sgtty.h sys/io/trioctl.h inttypes.h locale.h])
+ sgtty.h sys/io/trioctl.h locale.h])
 
   AC_CHECK_HEADERS([sys/buf.h], [], [],
    [#if HAVE_SYS_PARAM_H
@@ -24,5 +24,6 @@ AC_DEFUN([PU_SYSTEM],[
   AC_STRUCT_ST_BLKSIZE
 
   AC_CHECK_FUNCS_ONCE(lstat mkfifo setlocale)
-  AC_REQUIRE([gl_AC_TYPE_UINTMAX_T])
+  AC_REQUIRE([gl_INTTYPES_H])
+  AC_REQUIRE([gl_STDINT_H])
 ])




reply via email to

[Prev in Thread] Current Thread [Next in Thread]